<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 30.20</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <style>
        button {
            margin-top: 20px;
        }

        .container {
            height: 100vh;
            width: 100%;
        }

        h1 {
            color: #38D39F;
        }

        span {
            color: #38D39F;
        }
    </style>
</head>

<body>
    <form id="sign-up">
        <div class="container">
            <div class="row">
                <div class="col col-sm-6 col-md-6 col-lg-6 col-xl-6" style="height: 600px;display: flex;flex-direction: column;
        justify-content: space-around;">
                    <h1>Create a free account</h1>
                    <div class="container-fluid">
                        <div class="row" style="flex-direction: column">
                            <label for="name">Name</label>
                            <input id="name" placeholder="Your name" />
                        </div>
                        <div class="row" style="flex-direction: column">
                            <label for="email">E-mail</label>
                            <input id="email" placeholder="Your e-mail address" />
                        </div>
                        <div class="row" style="flex-direction: column">
                            <label for="password">Password</label>
                            <input id="password" placeholder="******" type="password" />
                        </div>
                        <div class="row" style="flex-direction: column">
                            <label for="confirm-password">Confirm Password</label>
                            <input id="confirm-password" type="password" placeholder="******" />
                        </div>
                        <div class="row">
                            <button  style="width: 100%;background: #38D39F;color: white;" class="btn"type="submit">Sign
                                Up</button>
                        </div>
                        <p style="display: flex;flex-wrap: wrap;
                align-items: center;">By signing up you agree to our <span><button style="color: #38D39F;"
                                    class="btn btn-link">Terms of Service</button></span> and <span><button
                                    style="color: #38D39F;" class="btn btn-link">Privacy Policy</button> </span></p>
                        <p>Already have an account?<span><button style="color: #38D39F;"
                                    class="btn btn-link">Login</button></span></p>
                    </div>
                </div>
    </form>
    <div class="col col-sm-6 col-md-6 col-lg-6 col-xl-6">
        <img style="position: absolute;" src="img/patterns-geometricos (13).png" width="455px" height="530px" />
        <img style="position: absolute; top: 50px;" src="img/undraw_invest_88iw.png" alt="undraw" width="503px"
            height="355px" />

    </div>
    </div>
    </div>

</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    var signUpForm = document.getElementById("sign-up")
    signUpForm.addEventListener("submit", (e) => {
        e.preventDefault();
        // B0 Khởi tạo đối tượng 
        var User = {
            username: "",
            password: "",
            email: "",
            confirmPassword: "",
        }
        // B1 Thu thập dữ liệu
        getDataToObject(User)
        // B2 Kiểm tra dữ liệu
        var validate = isDataValidate(User)
        if (validate == true) {
            //B3 Gọi API xử lý
            var xhr = new XMLHttpRequest()
            processApi(User,xhr)
            xhr.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATED) {
                    //B4 Xử lý hiển thị
                    var userSignUp = xhr.responseText;
                    console.log(userSignUp);
                }
            }
        }
        else{
            alert("ƯHat")
        }


    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    function getDataToObject(paramObject) {
        var vUsername = document.getElementById("name");
        var vPassword = document.getElementById("password");
        var vEmail = document.getElementById("email");
        var VConfirmPassword = document.getElementById("confirm-password");
        paramObject.username = vUsername.value.trim();
        paramObject.email = vEmail.value.trim();
        paramObject.password = vPassword.value.trim();
        paramObject.confirmPassword = VConfirmPassword.value.trim();
    }
    //Hàm kiểm tra dữ liệu
    function isDataValidate(paramObject) {
        if (paramObject.username == "") {
            alert("Hãy nhập username")
            return false
        }
        if (paramObject.email == "") {
            alert("Hãy nhập email")
            return false
        }
        if (isEmailValidate(paramObject.email) == false) {
            alert("Email không hợp lệ")
            return false
        }
        if (paramObject.password == "") {
            alert("Hãy nhập password")
            return false
        }
        if (paramObject.confirmPassword != paramObject.password) {
            alert("Mật khẩu xác nhận không trùng khớp")
            return false
        }
        return true
    }
    function isEmailValidate(paramEmail) {
        var vRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
        return vRegex.test(paramEmail)
        console.log(vRegex.test(paramEmail))
    }
    //
    function processApi(paramObject,paramHttp){
        paramHttp.open("POST",gBASE_URL,true)
        paramHttp.send(JSON.stringify(paramObject))
    }
</script>

</html>